package com.tzld.piaoquan.content.understanding.rocketmq.producer;

import com.alibaba.fastjson.JSON;
import com.tzld.piaoquan.content.understanding.util.RetryUtil;
import org.apache.rocketmq.client.apis.message.MessageId;
import org.apache.rocketmq.client.apis.producer.SendReceipt;
import org.apache.rocketmq.client.core.RocketMQClientTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.time.Duration;
import java.util.Map;
import java.util.Objects;

@Component
public class OldVersionRemainVideoUnderstandingProducer {
    @Autowired
    private RocketMQClientTemplate rocketMQClientTemplate;

    @Value("${video.understanding.old.version.remain.delay.topic:}")
    private String oldVersionRemainTopic;

    public MessageId syncSendDelayMessage(Map<String, Object> messageMap, Duration duration) {
        return RetryUtil.executeWithRetry(() -> {
            SendReceipt sendReceipt = rocketMQClientTemplate.syncSendDelayMessage(oldVersionRemainTopic, JSON.toJSONString(messageMap), duration);
            if (Objects.isNull(sendReceipt) || Objects.isNull(sendReceipt.getMessageId())) {
                throw new RuntimeException("transcode syncSendDelayMessage failure messageMap = " + messageMap);
            }
            return sendReceipt.getMessageId();
        }, "oldVersionRemainVideoSendDelayMessage");
    }
}
